/*****************************************************************************
* Copyright (c) 1990-2000 Digi International Inc., All Rights Reserved
* 
* This software contains proprietary and confidential information of Digi
* International Inc.  By accepting transfer of this copy, Recipient agrees
* to retain this software in confidence, to prevent disclosure to others,
* and to make no use of this software other than that for which it was
* delivered.  This is an unpublished copyrighted work of Digi International
* Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
* prohibited.
* 
* Restricted Rights Legend
*
* Use, duplication, or disclosure by the Government is subject to
* restrictions set forth in sub-paragraph (c)(1)(ii) of The Rights in
* Technical Data and Computer Software clause at DFARS 252.227-7031 or
* subparagraphs (c)(1) and (2) of the Commercial Computer Software -
* Restricted Rights at 48 CFR 52.227-19, as applicable.
*
* Digi International Inc. 11001 Bren Road East, Minnetonka, MN 55343
*
*****************************************************************************/


// Port.cpp: implementation of the CPort class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Port.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CPort, CConfigObject)

CPort::CPort(HKEY const hKeyRoot, CString const & strRegPath, CConfigObject const * const pParent) : CConfigObject(hKeyRoot, strRegPath, pParent)
{
   try
   {
      AffirmThrow(m_hKey != NULL);
      AffirmThrow(pParent != NULL);
      SetType(CConfigObject::PORT);

      // NOTE:
      //    Currently the registry path passed in to us is just a string
      //    representation of our port number.  If this ever changes, the
      //    code below must change also!
      SetPortNumber(atoi(strRegPath));
      SetComNumber(0); // Invalid, filled by subclass...

      // Get the line number from our line parent
      {
         CLine * pLine = (CLine *)pParent->GetParent()->GetParent();
         AffirmThrow(NULL != pLine);
         SetLineNumber(pLine->GetLineNumber());
      }
   }
   catch (CAffirmException)
   {
   }
}

CPort::~CPort()
{
   try
   {
   }
   catch (CAffirmException)
   {
   }
}

//////////////////////////////////////////////////////////////////////
// Get/Set parameters
//////////////////////////////////////////////////////////////////////

BOOL CPort::GetParameters(void)
{
   BOOL fSuccess = FALSE;

   try
   {
      fSuccess = TRUE;
   }
   catch (CAffirmException ae)
   {
   }

   return fSuccess;
}

BOOL CPort::SetParameters(void)
{
   BOOL fSuccess = FALSE;

   try
   {
      AffirmThrow(CConfigObject::SetParameters());
      fSuccess = TRUE;
   }
   catch (CAffirmException ae)
   {
   }

   return fSuccess;
}

//////////////////////////////////////////////////////////////////////
// Config data
//////////////////////////////////////////////////////////////////////

BOOL CPort::GetConfigData(void)
{
   BOOL fSuccess = FALSE;

   try
   {
      /*

      NOTE:
         This is currently undefined!

      CString strConfigDataRegPath;
      AffirmThrow(BuildConfigDataRegPath(strConfigDataRegPath));

      HKEY hConfigData = NULL;
      AffirmThrow(RegOpenKey(HKEY_LOCAL_MACHINE, strConfigDataRegPath, &hConfigData));
      AffirmThrow(hConfigData != NULL);

      try
      {
      }
      catch (CAffirmException ae)
      {
      }

      RegCloseKey(hConfigData);
      */

      fSuccess = TRUE;
   }
   catch (CAffirmException ae)
   {
   }

   return fSuccess;
}
